const { app, BrowserWindow, ipcMain } = require('electron');
const path = require('path');

let mainWindow;

function createWindow() {
  console.log('Icon path:', path.join(__dirname, 'EggTarutaru.ico'));
  mainWindow = new BrowserWindow({
    width: 460,
    height: 600,
    resizable: false,
    frame: false,
    icon: path.join(__dirname, '../launcher/images/EggTarutaru.ico'),
    webPreferences: {
      preload: path.join(__dirname, 'preload.js'),
      contextIsolation: true,
      nodeIntegration: false,
      sandbox: false
    }
  });

  mainWindow.loadFile('index.html');
  mainWindow.setMenuBarVisibility(false);

   mainWindow.webContents.openDevTools(); // 開発時のみ有効化

  mainWindow.on('closed', () => {
    mainWindow = null;
  });
}

app.whenReady().then(createWindow);

app.on('window-all-closed', () => {
  if (process.platform !== 'darwin') app.quit();
});

app.on('activate', () => {
  if (BrowserWindow.getAllWindows().length === 0) createWindow();
});

let childWindow = null;

ipcMain.on('open-child-window', (event, { url, label }) => {
  if (childWindow && !childWindow.isDestroyed()) {
    childWindow.webContents.send('set-url', { url, label });
    childWindow.focus();
    return;
  }

  childWindow = new BrowserWindow({
    width: 800,
    height: 600,
    frame: false,
    icon: path.join(__dirname, '../launcher/images/EggTarutaru.ico'),
    webPreferences: {
      preload: path.join(__dirname, 'preload.js'),
      contextIsolation: true,
      nodeIntegration: false,
      sandbox: false,
    },
  });

  childWindow.loadFile('child.html');

  childWindow.webContents.once('did-finish-load', () => {
    childWindow.webContents.send('set-url', { url, label });
  });

  childWindow.on('closed', () => {
    childWindow = null;
  });
});
